unit MainForm;

interface

{$I DTDBTree.Inc}

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, System.Variants,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VirtualTrees, DTADOTree,
  Vcl.ComCtrls, DBCtrls, Vcl.StdCtrls, Vcl.ToolWin, Vcl.Menus, Vcl.ImgList,
  Vcl.ActnList, XPStyleActnCtrls, Vcl.ActnMan, Vcl.ActnCtrls, Vcl.ActnMenus,
  Vcl.ExtCtrls, Vcl.AppEvnts, Vcl.Mask, Data.DB, Data.Win.ADODB, DBTables, DTTableTree,
  DBClient, Provider, Vcl.Buttons, DTDBTreeView, ResizeKit, JvStringHolder,
  JvComponentBase, JvBalloonHint, Vcl.ExtDlgs, System.Actions;


type
  TfrmMainForm = class(TForm)
    DTADOTree1: TDTADOTree;
    ActionManager1: TActionManager;
    ActNewChild: TAction;
    ActSave: TAction;
    ActCancel: TAction;
    ActDelete: TAction;
    ToolBar: TToolBar;
    tbNewSibling: TToolButton;
    tsSeparator: TToolButton;
    tbSave: TToolButton;
    tbDivider1: TToolButton;
    tbDivider3: TToolButton;
    tbCancel: TToolButton;
    tbDivider4: TToolButton;
    tbDelete: TToolButton;
    MainMenu1: TMainMenu;
    Ficheiro1: TMenuItem;
    NovoItemFilho: TMenuItem;
    Guardar1: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    Sair1: TMenuItem;
    Editar1: TMenuItem;
    Cancelar1: TMenuItem;
    N2: TMenuItem;
    Eliminar1: TMenuItem;
    tbDivider5: TToolButton;
    tbDivider6: TToolButton;
    ActClose: TAction;
    ActAbout: TAction;
    Ajuda1: TMenuItem;
    Acerca1: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    ActNext: TAction;
    ActGoUp: TAction;
    tbNext: TToolButton;
    tbGoUp: TToolButton;
    tbGoDown: TToolButton;
    ActGoDown: TAction;
    ActGoTop: TAction;
    tbGoTop: TToolButton;
    ImgListNodes: TImageList;
    Ver1: TMenuItem;
    primeiroitem1: TMenuItem;
    itemanterior1: TMenuItem;
    itemseguinte1: TMenuItem;
    itemseguintefilho1: TMenuItem;
    ActAddPicture: TAction;
    ActDeletePicture: TAction;
    Acrescentarimagem1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    Eliminarimagem1: TMenuItem;
    OpenDialog1: TOpenDialog;
    tbAddPicture: TToolButton;
    tbDeletePicture: TToolButton;
    tbDivider7: TToolButton;
    ImgListEnabled: TImageList;
    ImgListDisabled: TImageList;
    tbNewChild: TToolButton;
    tbDivider2: TToolButton;
    ActNewSibling: TAction;
    N6: TMenuItem;
    NovoItemPai: TMenuItem;
    PopupMenu1: TPopupMenu;
    N7: TMenuItem;
    NovoitemPrincipal1: TMenuItem;
    Novoitemdependente1: TMenuItem;
    N8: TMenuItem;
    Guardar2: TMenuItem;
    N9: TMenuItem;
    Cancelaralteracoes1: TMenuItem;
    N10: TMenuItem;
    Eliminaritem1: TMenuItem;
    N11: TMenuItem;
    Adicionarimagem1: TMenuItem;
    N12: TMenuItem;
    Eliminarimagem2: TMenuItem;
    Edit1: TEdit;
    tbSearch: TToolButton;
    ActSearch: TAction;
    ResizeKit1: TResizeKit;
    Idioma1: TMenuItem;
    English1: TMenuItem;
    N14: TMenuItem;
    Francais1: TMenuItem;
    N15: TMenuItem;
    Portugues1: TMenuItem;
    ActEnglish: TAction;
    ActFrench: TAction;
    ActPortuguese: TAction;
    ActSpanish: TAction;
    N13: TMenuItem;
    Espanol1: TMenuItem;
    StatusBar1: TStatusBar;
    JvBalloonHint1: TJvBalloonHint;
    JvStrHolder: TJvStrHolder;
    Splitter1: TSplitter;
    Panel1: TPanel;
    lblRecords: TLabel;
    lblCount: TLabel;
    lblItemName: TLabel;
    DBEdit1: TDBEdit;
    lblDependent: TLabel;
    lblHasDependent: TLabel;
    btPKNODE: TButton;
    btNode: TButton;
    Panel2: TPanel;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    lblImage: TLabel;
    DBImage1: TDBImage;
    DBMemo1: TDBMemo;
    lblNotes: TLabel;
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure ActSpanishUpdate(Sender: TObject);
    procedure ActSpanishExecute(Sender: TObject);
    procedure ActPortugueseUpdate(Sender: TObject);
    procedure ActPortugueseExecute(Sender: TObject);
    procedure ActFrenchUpdate(Sender: TObject);
    procedure ActFrenchExecute(Sender: TObject);
    procedure ActEnglishUpdate(Sender: TObject);
    procedure ActEnglishExecute(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBEdit1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActSearchUpdate(Sender: TObject);
    procedure ActSearchExecute(Sender: TObject);
    procedure DTADOTree1PaintText(Sender: TBaseVirtualTree;
      const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      TextType: TVSTTextType);
    procedure DTADOTree1GetImageIndexEx(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer;
      var ImageList: TCustomImageList);
    procedure DTADOTree1DBTreeCreateNode(Sender: TDTDBTreeView;
      Node: PVirtualNode; DataSet: TDataSet);
    procedure btNode1Click(Sender: TObject);
    procedure btPKNODE1Click(Sender: TObject);
    procedure ActNewSiblingUpdate(Sender: TObject);
    procedure ActNewSiblingExecute(Sender: TObject);
    procedure ActDeletePictureUpdate(Sender: TObject);
    procedure ActDeletePictureExecute(Sender: TObject);
    procedure ActAddPictureUpdate(Sender: TObject);
    procedure ActAddPictureExecute(Sender: TObject);
    procedure ActCancelUpdate(Sender: TObject);
    procedure ActCancelExecute(Sender: TObject);
    procedure ActSaveUpdate(Sender: TObject);
    procedure ActSaveExecute(Sender: TObject);
    procedure ActNewChildUpdate(Sender: TObject);
    procedure ActNewChildExecute(Sender: TObject);
    procedure ActDeleteUpdate(Sender: TObject);
    procedure ActDeleteExecute(Sender: TObject);
    procedure ActNextUpdate(Sender: TObject);
    procedure ActGoDownUpdate(Sender: TObject);
    procedure ActGoUpUpdate(Sender: TObject);
    procedure ActGoTopUpdate(Sender: TObject);
    procedure ActGoTopExecute(Sender: TObject);
    procedure ActGoDownExecute(Sender: TObject);
    procedure ActGoUpExecute(Sender: TObject);
    procedure ActNextExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ActAboutExecute(Sender: TObject);
    procedure ApplicationEvents1Hint(Sender: TObject);
    procedure ActCloseExecute(Sender: TObject);
    procedure ToolBarResize(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateParentHasChildrenValue(ParentKey: Variant);
    procedure Translate(Sender: TObject);
  public
    { Public declarations }
    MyRadio : TRadioGroup;
    MyListBox : TListBox;
    sLanguage : string; //determina o idioma do programa
    procedure SetModified(Value: Boolean);
  end;

const
  //Messages
  MsgModified   = 0; //A tabela TEM alteraes no guardadas
  MsgNoModified = 1; //A tabela no tem alteraes por guardar
  MsgSave = 2; //As alteraes no foram guardadas. Guardar agora?
  MsgAttention = 3; //Ateno!
  MsgItem1 = 4; //O item seleccionado tem dependentes.
  MsgItem2 = 5; //No pode ser eliminado.
  MsgInfor = 6; //Informao
  MsgDelete = 7; //Eliminar o item ''%s''?
  MsgDelPicture = 8;//Eliminar a imagem?
  MsgMain = 9; //Novo item Principal
  MsgNew1 = 10; //Digite o nome do novo item:
  MsgDepend = 11; //No pode criar dependentes do item seleccionado.
  MsgNew2 = 12; //Novo item Dependente
  MsgValues = 13; //Valores dos campos da tabela:
  MsgNode = 14; //DTADOTree: Ndulo %s
  MsgYDepend = 15; //Com dependente(s)
  MsgNDepend = 16; //Sem dependente(s)

var
  frmMainForm: TfrmMainForm;
  NewColor: TColor;

implementation

uses ResourceLocalizer,
     SettingsUnit,
     jpeg,
     ClipBrd,
     DTCommon,
     ShellAPI,
     DM,
     About;

{$R *.dfm}
{$R languages.RES}

function MyInputQuery(const ACaption,APrompt:string;var Value:string):Boolean;

  function GetAveCharSize(Canvas: TCanvas): TPoint;
  var
    I      : Integer;
    Buffer : array[0..51] of Char;
  begin
    for I := 0 to 25 do
      Buffer[I] := Chr(I + Ord('A'));
    for I := 0 to 25 do
      Buffer[I + 26] := Chr(I + Ord('a'));
    GetTextExtentPoint(Canvas.Handle,Buffer,52,TSize(Result));
    Result.X := Result.X div 52;
  end;

var
  Form                                 : TForm;
  Prompt                               : TLabel;
  Edit                                 : TEdit;
  DialogUnits                          : TPoint;
  ButtonTop, ButtonWidth, ButtonHeight : Integer;
begin
  Result := False;
  Form := TForm.Create(Application);
  with Form do
   try
     Canvas.Font := Font;
     DialogUnits := GetAveCharSize(Canvas);
     BorderStyle := bsDialog;
     Caption := ACaption;
     ClientWidth := MulDiv(180, DialogUnits.X, 4);
     Position := poScreenCenter;
     Prompt := TLabel.Create(Form);
     with Prompt do
      begin
        Parent := Form;
        Caption := APrompt;
        Left := MulDiv(8, DialogUnits.X, 4);
        Top := MulDiv(8, DialogUnits.Y, 8);
        Constraints.MaxWidth := MulDiv(164, DialogUnits.X, 4);
        WordWrap := True;
      end;
      Edit := TEdit.Create(Form);
      with Edit do
       begin
         {Usando a fonte Wingdings e a letra "ele" em minsculo, simula-se
         as "bolinhas" no lugar       de astersco da senha}
         //Font.Name := 'Wingdings';
         //PasswordChar := 'l';
         Parent := Form;
         Left := Prompt.Left;
         Top := Prompt.Top + Prompt.Height + 5;
         Width := MulDiv(164, DialogUnits.X, 4);
         MaxLength := 255;
         Text := Value;
         SelectAll;
       end;
      ButtonTop := Edit.Top + Edit.Height + 15;
      ButtonWidth := MulDiv(50, DialogUnits.X, 4);
      ButtonHeight := MulDiv(14, DialogUnits.Y, 8);
      with TButton.Create(Form) do
       begin
         Parent := Form;
         Caption := 'Ok';
         ModalResult := mrOk;
         Default := True;
         SetBounds(MulDiv(38,DialogUnits.X,4),ButtonTop,ButtonWidth,ButtonHeight);
       end;
      with TButton.Create(Form) do
       begin
         Parent := Form;
         Caption := 'Cancel';
         ModalResult := mrCancel;
         Cancel := True;
         SetBounds(MulDiv(92,DialogUnits.X,4),Edit.Top+Edit.Height+15,ButtonWidth,ButtonHeight);
         Form.ClientHeight := Top + Height + 13;
       end;
      if ShowModal = mrOk then
       begin
         Value := Edit.Text;
         Result := True;
       end;
   finally
     Form.Free;
   end;//try
end;

procedure TfrmMainForm.ApplicationEvents1Hint(Sender: TObject);
begin
  //mostrar o hint dos botes na StatusBar
  StatusBar1.Panels[0].Text := Application.Hint;
end;

procedure TfrmMainForm.SetModified(Value: Boolean);
begin
  (* conforme h ou no alteraes  tabela,
   assim  mostrada uma mensagem na barra de status *)
  if Value then //se a varivel  true, houve mudanas
    StatusBar1.Panels[1].Text := JvStrHolder.Strings[MsgModified]
  else
    StatusBar1.Panels[1].Text := JvStrHolder.Strings[MsgNoModified];
end;

procedure TfrmMainForm.UpdateParentHasChildrenValue(ParentKey: Variant);
var
  HasChildren : Boolean;
  BMark       : TBytes;
begin
  with DataModule1.ADOtblProducts, DTADOTree1.DBTreeFields do
    begin
      BMark := Bookmark;
      HasChildren := Locate(ParentFieldName, ParentKey, []);
      if Locate(KeyFieldName, ParentKey, []) then
        begin
          Edit;
          FieldValues[HasChildrenFieldName] := HasChildren;
          Post;
          UpdateBatch(arAll);
        end;//if
      Bookmark := BMark;
    end;//with
end;

procedure TfrmMainForm.FormCreate(Sender: TObject);
begin
  MyRadio := TRadioGroup.Create(Self);
  with MyRadio do
    begin
      Parent := Panel1;
      Width := 133;
      Height := 40;
      Top := 40;
      Left := 144;
      Visible := false;
    end;
  TResourceLocalizer.GetLanguages(MyRadio.Items);

  MyListBox := TListBox.Create(Self);
  with MyListBox do
    begin
      Parent := Panel1;
      Width := 132;
      Height := 26;
      Top := 8;
      Left := 144;
      Visible := false;
    end;

  StatusBar1.Panels[1].Text := JvStrHolder.Strings[MsgNoModified];
  NewColor := GetSysColor(COLOR_BTNFACE);
  //de SettingsUnit
  LoadMainSettings;
  //se a tabela no estiver aberta
  if not DataModule1.ADOtblProducts.Active then
    begin
      with DataModule1.ADOtblProducts do
        begin
          TableName := 'Processing';
          Open;
          //tabela ordenada pelo primary key (PK)
          Sort := 'PK';
          //posiciona-se no 1. registo
          First;
          lblCount.Caption := IntToStr(RecordCount);
        end; //with
    end //begin
  else
    Exit;
end;

procedure TfrmMainForm.FormShow(Sender: TObject);
begin
  frmMainForm.Color := NewColor;
end;

procedure TfrmMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caNone;
  if DataModule1.ADOtblProducts.State in [dsEdit] then
    ActCloseExecute(Self)
  else
    begin
      DataModule1.ADOtblProducts.Close;
      SaveMainSettings;
      Action := caFree;
    end;
end;

procedure TfrmMainForm.ActAboutExecute(Sender: TObject);
begin
  //mostra janela AboutBox
  AboutBox.ShowModal;
end;

procedure TfrmMainForm.ActAddPictureExecute(Sender: TObject);
(* adiciona imagem jpeg usando DBImage;
  no  necessrio para imagens .bmp *)
var
  imag : TPicture;//TJpegImage;
begin
  OpenDialog1.InitialDir := ExtractFilePath(Application.ExeName);
  if OpenDialog1.Execute() then
    begin
      imag := TPicture.Create();
      imag.LoadFromFile(OpenDialog1.FileName);
      Clipboard.Assign(imag);
      DataModule1.ADOtblProducts.Edit;
      DBImage1.PasteFromClipboard;
      ActSaveExecute(Self);
      imag.Free;
    end;
end;

procedure TfrmMainForm.ActAddPictureUpdate(Sender: TObject);
begin
  ActAddPicture.Enabled := DataModule1.ADOtblProductsIMAGEM.Value = nil;
end;

procedure TfrmMainForm.ActCancelExecute(Sender: TObject);
//cancelar alteraes
begin
  DataModule1.ADOtblProducts.CancelBatch;
end;

procedure TfrmMainForm.ActCancelUpdate(Sender: TObject);
begin
  ActCancel.Enabled := DataModule1.ADOtblProducts.State in [dsEdit,dsInsert];
end;

procedure TfrmMainForm.ActCloseExecute(Sender: TObject);
var
  Action : TCloseAction;
  iCode  : Word;
begin
  Action := caNone;
  if DataModule1.ADOtblProducts.State in [dsEdit] then
    begin
      iCode := Application.MessageBox(PChar(JvStrHolder.Strings[MsgSave]),
                           PChar(JvStrHolder.Strings[MsgAttention]),
                           MB_YESNOCANCEL+MB_ICONQUESTION+MB_DEFBUTTON1+MB_APPLMODAL);
      case iCode of
        idYes : begin
                  ActSaveExecute(Self);
                  DataModule1.ADOtblProducts.Close;
                  SaveMainSettings;
                  Action := caFree;
                  Close;
                end;
        idNo  : begin
                  ActCancelExecute(Self);
                  DataModule1.ADOtblProducts.Close;
                  SaveMainSettings;
                  Action := caFree;
                  Close;
                end;
        idCancel : Abort; //no fecha o programa
      end;//do case
    end//do begin
  else
    begin
      DataModule1.ADOtblProducts.Close;
      SaveMainSettings;
      Action := caFree;
      Close;
    end;
end;

procedure TfrmMainForm.ActDeleteExecute(Sender: TObject);
//eliminar item
var
  ParentValue : Variant;
  iCode       : Word;
begin
  if DTADOTree1.RecordHasChildren then
    Application.MessageBox(PChar(JvStrHolder.Strings[MsgItem1] + ^M +
                PChar(JvStrHolder.Strings[MsgItem2])),
                PChar(JvStrHolder.Strings[MsgInfor]),
                MB_OK+MB_ICONINFORMATION+MB_APPLMODAL)
    //MessageBox(0,PChar('O item seleccionado tem dependentes.' + ^M +
    //           'No pode ser eliminado.'),
    //           'Informao',mb_IconInformation)
  else
    begin
      iCode := Application.MessageBox(PChar(Format(JvStrHolder.Strings[MsgDelete],
                           [DataModule1.ADOtblProductsNOME.AsString])),
                           PChar(JvStrHolder.Strings[MsgAttention]),
                           MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2+MB_APPLMODAL);
      {
      iCode := MessageBox(0,PChar(Format('Eliminar o item ''%s''?',
               [DataModule1.ADOtblProductsNOME.AsString])),
               'Ateno!',mb_IconQuestion+mb_YesNo+mb_DefButton2);
      }
      case iCode of
        idYes : begin
                  with DataModule1.ADOtblProducts, DTADOTree1.DBTreeFields do
                    begin
                      DisableControls;
                      ParentValue := FieldValues[ParentFieldName];
                      Delete;
                      UpdateParentHasChildrenValue(ParentValue);
                      UpdateBatch(arAll);
                      EnableControls;
                      lblCount.Caption := IntToStr(RecordCount);
                    end;
                end;
      end;//case
    end;//else
end;

procedure TfrmMainForm.ActDeleteUpdate(Sender: TObject);
begin
  ActDelete.Enabled := DataModule1.ADOtblProducts.IsEmpty = false;
end;

procedure TfrmMainForm.ActDeletePictureExecute(Sender: TObject);
//elimina imagem
var
  iCode : Word;
begin
  iCode := Application.MessageBox(PChar(JvStrHolder.Strings[MsgDelPicture]),
                           PChar(JvStrHolder.Strings[MsgAttention]),
                           MB_YESNO+MB_ICONQUESTION+MB_DEFBUTTON2+MB_APPLMODAL);
  //MessageBox(0,PChar('Eliminar a imagem?),
  //           'Ateno',mb_IconQuestion)
  case iCode of
    idYes : begin
              DataModule1.ADOtblProducts.Edit;
              DataModule1.ADOtblProductsIMAGEM.Clear;
              DataModule1.ADOtblProducts.Post;
            end;
  end;
end;

procedure TfrmMainForm.ActDeletePictureUpdate(Sender: TObject);
begin
  ActDeletePicture.Enabled := DataModule1.ADOtblProductsIMAGEM.Value <> nil;
end;

procedure TfrmMainForm.ActGoDownExecute(Sender: TObject);
//ir para o item dependente
begin
  DTADOTree1.GoDown;
end;

procedure TfrmMainForm.ActGoDownUpdate(Sender: TObject);
//se no tiver dependente, fica disable
begin
  ActGoDown.Enabled := DataModule1.ADOtblProducts.FieldValues['HasDependent'] = true;
end;

procedure TfrmMainForm.ActGoTopExecute(Sender: TObject);
//ir para o primeiro item
begin
  DTADOTree1.GoTop;
end;

procedure TfrmMainForm.ActGoTopUpdate(Sender: TObject);
//se estiver no primeiro item (PK = 1), fica disable
begin
  ActGoTop.Enabled := DataModule1.ADOtblProductsPK.Value <> 1;
end;

procedure TfrmMainForm.ActGoUpExecute(Sender: TObject);
//ir para o item anterior
begin
  DTADOTree1.GoUp;
end;

procedure TfrmMainForm.ActGoUpUpdate(Sender: TObject);
//se for o ndulo principal, fica disable
begin
  ActGoUp.Enabled := DataModule1.ADOtblProductsNODE.Value <> 0;
end;

procedure TfrmMainForm.ActNewChildExecute(Sender: TObject);
//novo child - dependente
var
  Node        : PVirtualNode;
  ParentValue : Variant;
  I           : byte;
  X, sNome    : string;
  bFlag       : boolean;
begin
  sNome := '';
  bFlag := false;
  //determinar qual o nvel, sendo que o mximo  4
  Node := DTADOTree1.FocusedNode;
  //se for o ltimo nvel
  if DTADOTree1.GetNodeLevel(Node) = 4 then
    begin
      Application.MessageBox(PChar(JvStrHolder.Strings[MsgDepend]),
                  PChar(JvStrHolder.Strings[MsgAttention]),
                  MB_OK+MB_ICONINFORMATION+MB_APPLMODAL);
      //MessageBox(0,PChar('No pode criar dependentes do item seleccionado.'),
      //         'Ateno!',mb_IconStop);
      Exit;
    end
  else
    begin
      bFlag := MyInputQuery(JvStrHolder.Strings[MsgNew2],
               JvStrHolder.Strings[MsgNew1], sNome);
      {
      InputQuery('Novo item Dependente',
                 'Digite o nome do novo item:', sNome);
      }
      if bFlag and (Trim(sNome) <> '') then //a funo Trim ignora os espaos
        begin
          with DataModule1.ADOtblProducts, DTADOTree1.DBTreeFields do
            begin
              DisableControls;
              (* determinar qual dos campos (isPrimeiro ... isQuarto)
               est marcado como true; o novo item tambm ficar
               marcado como true no mesmo campo *)
              for I := 5 to 8 do //isPrimeiro  o campo 5; isQuarto  o 8
                begin
                  if Fields[i].AsBoolean = true then
                    X := Fields[I+1].FieldName;
                end;
              ParentValue := FieldValues[KeyFieldName];
              Append;
              FieldValues[ParentFieldName] := ParentValue;
              FieldValues[HasChildrenFieldName] := False;
              FieldByName(X).AsBoolean := true;
              Post;
              UpdateBatch(arAll);
              Edit;
              FieldValues[ListFieldName] := sNome;
              Post;
              UpdateParentHasChildrenValue(ParentValue);
              EnableControls;
              lblCount.Caption := IntToStr(RecordCount);
            end;//with
        end //if
      else //se no digitou nada
        ActCancelExecute(Self);
  end;//if
end;

procedure TfrmMainForm.ActNewChildUpdate(Sender: TObject);
begin
  ActNewChild.Enabled := ActSave.Enabled = false;
end;

procedure TfrmMainForm.ActNewSiblingExecute(Sender: TObject);
//novo sibling - irmo
var
  ParentValue : Variant;
  I           : byte;
  X, sNome    : string;
  bFlag       : boolean;
begin
  sNome := '';
  bFlag := false;
  bFlag := MyInputQuery(JvStrHolder.Strings[MsgMain],
           JvStrHolder.Strings[MsgNew1], sNome);
  {
  InputQuery('Novo item Principal',
             'Digite o nome do novo item:', sNome);
  }
  if bFlag and (Trim(sNome) <> '') then //a funo Trim ignora os espaos
    begin
      with DataModule1.ADOtblProducts, DTADOTree1.DBTreeFields do
        begin
          DisableControls;
          (* determinar qual dos campos (isPrimeiro ... isQuinto)
           est marcado como true; o novo item tambm ficar
           marcado como true no mesmo campo *)
          for I := 5 to 9 do //isPrimeiro  o campo 5; isQuinto  o 9
            begin
              if Fields[i].AsBoolean = true then
                X := Fields[I].FieldName;
            end;
          ParentValue := FieldValues[ParentFieldName];
          Append;
          FieldValues[ParentFieldName] := ParentValue;
          FieldValues[HasChildrenFieldName] := False;
          FieldByName(X).AsBoolean := true;
          Post;
          UpdateBatch(arAll);
          Edit;
          FieldValues[ListFieldName] := sNome;
          Post;
          UpdateBatch(arAll);
          EnableControls;
          lblCount.Caption := IntToStr(RecordCount);
        end;//with
    end
  else
    ActCancelExecute(Self);
end;

procedure TfrmMainForm.ActNewSiblingUpdate(Sender: TObject);
begin
  ActNewSibling.Enabled := ActSave.Enabled = false;
end;

procedure TfrmMainForm.ActNextExecute(Sender: TObject);
//percorrer todos os itens
begin
  DTADOTree1.Next;
end;

procedure TfrmMainForm.ActNextUpdate(Sender: TObject);
//se for o final da rvore, passa a disable
begin
  ActNext.Enabled := DTADOTree1.EndOfTree = false;
end;

procedure TfrmMainForm.ActSaveExecute(Sender: TObject);
//guardar
begin
  DataModule1.ADOtblProducts.Post;
  DataModule1.ADOtblProducts.UpdateBatch(arAll);
end;

procedure TfrmMainForm.ActSaveUpdate(Sender: TObject);
begin
  ActSave.Enabled := DataModule1.ADOtblProducts.State in [dsEdit,dsInsert];
end;

procedure TfrmMainForm.ActSearchExecute(Sender: TObject);
//search for an item
begin
  with DataModule1.ADOtblProducts, DTADOTree1.DBTreeFields do
    begin
      Locate('NOME',Edit1.Text,[loPartialKey]);
      Focused;
    end;
end;

procedure TfrmMainForm.ActSearchUpdate(Sender: TObject);
begin
  ActSearch.Enabled := Trim(Edit1.Text) <> '';
end;

procedure TfrmMainForm.btPKNODE1Click(Sender: TObject);
var
  KeyValue,ParentValue : Variant;
begin
  with DataModule1.ADOtblProducts, DTADOTree1.DBTreeFields do
    begin
      KeyValue := FieldValues[KeyFieldName];
      ParentValue := FieldValues[ParentFieldName];
    end;
  Application.MessageBox(PChar(Format(JvStrHolder.Strings[MsgValues] + ^M +
              'PK = %s' + ^M +
              'NODE = %s',
              [IntToStr(KeyValue),IntToStr(ParentValue)])),
              PChar(JvStrHolder.Strings[MsgInfor]),
              MB_OK+MB_ICONINFORMATION+MB_APPLMODAL);
  {
  MessageBox(0,PChar(Format('Valores dos campos da tabela:' + ^M + ^M +
             'PK = %s' + ^M + ^M +
             'NODE = %s',
             [IntToStr(KeyValue),IntToStr(ParentValue)])),
             'Informao',mb_IconInformation);
  }
end;

procedure TfrmMainForm.btNode1Click(Sender: TObject);
var
  Node : PVirtualNode;
begin
  Node := DTADOTree1.FocusedNode;
  Application.MessageBox(PChar(Format(JvStrHolder.Strings[MsgNode],
              [IntToStr(DTADOTree1.GetNodeLevel(Node))])),
              PChar(JvStrHolder.Strings[MsgInfor]),
              MB_OK+MB_ICONINFORMATION+MB_APPLMODAL);
  {
  MessageBox(0,PChar(Format('DTADOTree: Ndulo n. %s',
             [IntToStr(DTADOTree1.GetNodeLevel(Node))])),
             'Informao',mb_IconInformation);
  }
end;

procedure TfrmMainForm.DTADOTree1DBTreeCreateNode(Sender: TDTDBTreeView;
  Node: PVirtualNode; DataSet: TDataSet);
begin
  with DataSet do
    Sender.ListNode[Node].Param :=
      VarArrayOf([FieldByName('IsPrimeiro').AsBoolean,
      FieldByName('IsSegundo').AsBoolean,
      FieldByName('IsTerceiro').AsBoolean,
      FieldByName('IsQuarto').AsBoolean,
      FieldByName('IsQuinto').AsBoolean]);
end;

procedure TfrmMainForm.DTADOTree1GetImageIndexEx(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer;
  var ImageList: TCustomImageList);
begin
  ImageList := ImgListNodes;
  with (Sender as TDTADOTree).ListNode[Node] do
    begin
      if Param[0] then
        ImageIndex := 0
      else if Param[1] then
        ImageIndex := 1
      else if Param[2] then
        ImageIndex := 2
      else if Param[3] then
        ImageIndex := 3
      else if Param[4] then
        ImageIndex := 4;
    end;
end;

procedure TfrmMainForm.DTADOTree1PaintText(Sender: TBaseVirtualTree;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
begin
  with (Sender as TDTADOTree).ListNode[Node] do
    begin
      if Param[0] then
        TargetCanvas.Font.Color := clNavy
      else if Param[1] then
        TargetCanvas.Font.Color := clBlack
      else if Param[2] then
        TargetCanvas.Font.Color := clGreen
      else if Param[3] then
        TargetCanvas.Font.Color := clRed
      else if Param[4] then
        TargetCanvas.Font.Color := clMaroon;
    end;
end;

procedure TfrmMainForm.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
var
  Status : Boolean;
  sTexto : String;
begin
  with StatusBar1 do
    begin
      //varivel de modificao da tabela
      if Panel.Index = 1 then
        begin
          if Panels[1].Text = JvStrHolder.Strings[MsgModified] then //AntSLMessages.Strings[MsgNoModified]
            begin
              Status := true;
              sTexto := JvStrHolder.Strings[MsgModified];
           end
        else
          begin
            Status := false;
            Canvas.Font.Color := clBlack;
            sTexto := JvStrHolder.Strings[MsgNoModified];
          end;
        end;//if Panel
      if Status then
        begin
          Canvas.Font.Color := clRed;
          Canvas.FillRect(Rect);
        end;//if Status
      SetTextAlign(Canvas.Handle,TA_CENTER);
      Canvas.TextOut((Rect.Left+Rect.Right) div 2, 6,sTexto);
    end;//with
end;

procedure TfrmMainForm.DBEdit1Change(Sender: TObject);
var
  Node : PVirtualNode;
begin
  Node := DTADOTree1.FocusedNode;
  if DTADOTree1.HasChildren[Node] then
    lblHasDependent.Caption := JvStrHolder.Strings[MsgYDepend]
  else
    lblHasDependent.Caption := JvStrHolder.Strings[MsgNDepend];
end;

procedure TfrmMainForm.Edit1Click(Sender: TObject);
begin
  with Edit1 do
    begin
      Color := clInfoBK;
      Text := '';
    end;
end;

procedure TfrmMainForm.Edit1Exit(Sender: TObject);
begin
  Edit1.Color := clWindow;
end;

procedure TfrmMainForm.ToolBarResize(Sender: TObject);
var
  i,btnWidth : Integer;
begin
  btnWidth := ToolBar.Width div ToolBar.ControlCount;
  for i := 0 to ToolBar.ControlCount - 1 do
  begin
    ToolBar.Controls[i].Left := ToolBar.Controls[i].Tag * btnWidth;
    ToolBar.Controls[i].Width := btnWidth;
  end;
end;

procedure TfrmMainForm.Translate(Sender: TObject);
var
  i : integer;
begin
  with frmMainForm do
    begin
      Caption := MyListBox.Items[0];
      Acerca1.Caption := MyListBox.Items[1];
      Acrescentarimagem1.Caption := MyListBox.Items[2];
      Adicionarimagem1.Caption := MyListBox.Items[3];
      Ajuda1.Caption := MyListBox.Items[4];
      btNode.Caption := MyListBox.Items[5];
      btPKNODE.Caption := MyListBox.Items[6];
      Cancelar1.Caption := MyListBox.Items[7];
      Cancelaralteracoes1.Caption := MyListBox.Items[8];
      Editar1.Caption := MyListBox.Items[9];
      Eliminar1.Caption := MyListBox.Items[10];
      Eliminarimagem1.Caption := MyListBox.Items[11];
      Eliminarimagem2.Caption := MyListBox.Items[12];
      Eliminaritem1.Caption := MyListBox.Items[13];
      English1.Caption := MyListBox.Items[14];
      Espanol1.Caption := MyListBox.Items[15];
      Ficheiro1.Caption := MyListBox.Items[16];
      Francais1.Caption := MyListBox.Items[17];
      Guardar1.Caption := MyListBox.Items[18];
      Guardar2.Caption := MyListBox.Items[19];
      Idioma1.Caption := MyListBox.Items[20];
      Itemanterior1.Caption := MyListBox.Items[21];
      Itemseguinte1.Caption := MyListBox.Items[22];
      Itemseguintefilho1.Caption := MyListBox.Items[23];
      lblDependent.Caption := MyListBox.Items[24];
      lblImage.Caption := MyListBox.Items[25];
      lblItemName.Caption := MyListBox.Items[26];
      lblNotes.Caption := MyListBox.Items[27];
      lblRecords.Caption := MyListBox.Items[28];
      Novoitemdependente1.Caption := MyListBox.Items[29];
      Novoitemfilho.Caption := MyListBox.Items[30];
      Novoitempai.Caption := MyListBox.Items[31];
      NovoitemPrincipal1.Caption := MyListBox.Items[32];
      Portugues1.Caption := MyListBox.Items[33];
      primeiroitem1.Caption := MyListBox.Items[34];
      Sair1.Caption := MyListBox.Items[35];
      Ver1.Caption := MyListBox.Items[36];
      ActAbout.Hint := MyListBox.Items[37];
      ActAddPicture.Hint := MyListBox.Items[38];
      ActCancel.Hint := MyListBox.Items[39];
      ActClose.Hint := MyListBox.Items[40];
      ActDelete.Hint := MyListBox.Items[41];
      ActDeletePicture.Hint := MyListBox.Items[42];
      ActEnglish.Hint := MyListBox.Items[43];
      ActFrench.Hint := MyListBox.Items[44];
      ActGoDown.Hint := MyListBox.Items[45];
      ActGoTop.Hint := MyListBox.Items[46];
      ActGoUp.Hint := MyListBox.Items[47];
      ActNewChild.Hint := MyListBox.Items[48];
      ActNewSibling.Hint := MyListBox.Items[49];
      ActNext.Hint := MyListBox.Items[50];
      ActPortuguese.Hint := MyListBox.Items[51];
      ActSave.Hint := MyListBox.Items[52];
      ActSearch.Hint := MyListBox.Items[53];
      ActSpanish.Hint := MyListBox.Items[54];
      for i := JvStrHolder.Strings.Count -1 downto 0 do
        JvStrHolder.Strings.Delete(i);
      for i := 55 to 71 do
        JvStrHolder.Strings.Add(MyListBox.Items[i]);
      OpenDialog1.Filter := MyListBox.Items[72];
      OpenDialog1.Title := MyListBox.Items[73];
    end;
  with AboutBox do
    begin
      Caption := MyListBox.Items[74];
      Comments1.Caption := MyListBox.Items[75];
      Comments2.Caption := MyListBox.Items[76];
      Comments3.Caption := MyListBox.Items[77];
      Comments4.Caption := MyListBox.Items[78];
      Comments5.Caption := MyListBox.Items[79];
      Comments6.Caption := MyListBox.Items[80];
      Copyright.Caption := MyListBox.Items[81];
      lblemail.Caption := MyListBox.Items[82];
      OKButton.Caption := MyListBox.Items[83];
      ProductName.Caption := MyListBox.Items[84];
      Version.Caption := MyListBox.Items[85];
    end;
end;

procedure TfrmMainForm.ActEnglishExecute(Sender: TObject);
var
  LanguageResOffset : integer;
begin
  MyListBox.Items.Clear;
  sLanguage := 'English';
  LanguageResOffset := Integer(MyRadio.Items.Objects[0]);
  TResourceLocalizer.GetStrings(MyListBox.Items,LanguageResOffset,[1,2,3,4,5,6,7,
       8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
       33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,
       57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
       81,82,83,84,85,86]);
  Translate(Self);
  Invalidate;
end;

procedure TfrmMainForm.ActEnglishUpdate(Sender: TObject);
begin
  ActEnglish.Enabled := sLanguage <> 'English';
end;

procedure TfrmMainForm.ActFrenchExecute(Sender: TObject);
var
  LanguageResOffset : integer;
begin
  MyListBox.Items.Clear;
  sLanguage := 'Franais';
  LanguageResOffset := Integer(MyRadio.Items.Objects[1]);
  TResourceLocalizer.GetStrings(MyListBox.Items,LanguageResOffset,[1,2,3,4,5,6,7,
       8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
       33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,
       57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
       81,82,83,84,85,86]);
  Translate(Self);
  Invalidate;
end;

procedure TfrmMainForm.ActFrenchUpdate(Sender: TObject);
begin
  ActFrench.Enabled := sLanguage <> 'Franais';
end;

procedure TfrmMainForm.ActPortugueseExecute(Sender: TObject);
var
  LanguageResOffset : integer;
begin
  MyListBox.Items.Clear;
  sLanguage := 'Portugus';
  LanguageResOffset := Integer(MyRadio.Items.Objects[2]);
  TResourceLocalizer.GetStrings(MyListBox.Items,LanguageResOffset,[1,2,3,4,5,6,7,
       8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
       33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,
       57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
       81,82,83,84,85,86]);
  Translate(Self);
  Invalidate;
end;

procedure TfrmMainForm.ActPortugueseUpdate(Sender: TObject);
begin
  ActPortuguese.Enabled := sLanguage <> 'Portugus';
end;

procedure TfrmMainForm.ActSpanishExecute(Sender: TObject);
var
  LanguageResOffset : integer;
begin
  MyListBox.Items.Clear;
  sLanguage := 'Espaol';
  LanguageResOffset := Integer(MyRadio.Items.Objects[3]);
  TResourceLocalizer.GetStrings(MyListBox.Items,LanguageResOffset,[1,2,3,4,5,6,7,
       8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
       33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,
       57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
       81,82,83,84,85,86]);
  Translate(Self);
  Invalidate;
end;

procedure TfrmMainForm.ActSpanishUpdate(Sender: TObject);
begin
  ActSpanish.Enabled := sLanguage <> 'Espaol';
end;

end.
