unit SettingsUnit;

interface

uses
  System.INIFiles, System.SysUtils, Vcl.Graphics, Vcl.Forms, DM, MainForm, About;

procedure LoadMainSettings;
procedure SaveMainSettings;
procedure DefaultMainSettings;
procedure LoadAboutSettings;
procedure SaveAboutSettings;
procedure DefaultAboutSettings;

implementation

procedure LoadMainSettings;
var
  SettingsFileName : TFileName;
  SettingsFile     : TIniFile;
begin
  SettingsFileName := ExtractFilePath(ParamStr(0)) +
    '\settings.ini';
  if FileExists(SettingsFileName) then
  begin
    SettingsFile := TIniFile.Create(SettingsFileName);
    try
      with SettingsFile, frmMainForm do
        begin
          sLanguage := ReadString('MAINFORM','sLanguage',sLanguage);
          Height := ReadInteger('MAINFORM','frmMainFormHeight',Height);
          Width := ReadInteger('MAINFORM','frmMainFormWidth',Width);
          Left := ReadInteger('MAINFORM','frmMainFormLeft',Left);
          Top := ReadInteger('MAINFORM','frmMainFormTop',Top);
          Caption := ReadString('MAINFORM','Caption',Caption);
          Acerca1.Caption := ReadString('MAINFORM','Acerca1Caption',Acerca1.Caption);
          Acrescentarimagem1.Caption := ReadString('MAINFORM','Acrescentarimagem1Caption',Acrescentarimagem1.Caption);
          Adicionarimagem1.Caption := ReadString('MAINFORM','Adicionarimagem1Caption',Adicionarimagem1.Caption);
          Ajuda1.Caption := ReadString('MAINFORM','Ajuda1Caption',Ajuda1.Caption);
          btNode.Caption := ReadString('MAINFORM','btNodeCaption',btNode.Caption);
          btPKNODE.Caption := ReadString('MAINFORM','btPKNODECaption',btPKNODE.Caption);
          Cancelar1.Caption := ReadString('MAINFORM','Cancelar1Caption',Cancelar1.Caption);
          Cancelaralteracoes1.Caption := ReadString('MAINFORM','Cancelaralteracoes1Caption',Cancelaralteracoes1.Caption);
          Editar1.Caption := ReadString('MAINFORM','Editar1Caption',Editar1.Caption);
          Eliminar1.Caption := ReadString('MAINFORM','Eliminar1Caption',Eliminar1.Caption);
          Eliminarimagem1.Caption := ReadString('MAINFORM','Eliminarimagem1Caption',Eliminarimagem1.Caption);
          Eliminarimagem2.Caption := ReadString('MAINFORM','Eliminarimagem2Caption',Eliminarimagem2.Caption);
          Eliminaritem1.Caption := ReadString('MAINFORM','Eliminaritem1Caption',Eliminaritem1.Caption);
          English1.Caption := ReadString('MAINFORM','English1Caption',English1.Caption);
          Espanol1.Caption := ReadString('MAINFORM','Espanol1Caption',Espanol1.Caption);
          Ficheiro1.Caption := ReadString('MAINFORM','Ficheiro1Caption',Ficheiro1.Caption);
          Francais1.Caption := ReadString('MAINFORM','Francais1Caption',Francais1.Caption);
          Guardar1.Caption := ReadString('MAINFORM','Guardar1Caption',Guardar1.Caption);
          Guardar2.Caption := ReadString('MAINFORM','Guardar2Caption',Guardar2.Caption);
          Idioma1.Caption := ReadString('MAINFORM','Idioma1Caption',Idioma1.Caption);
          Itemanterior1.Caption := ReadString('MAINFORM','Itemanterior1Caption',Itemanterior1.Caption);
          Itemseguinte1.Caption := ReadString('MAINFORM','Itemseguinte1Caption',Itemseguinte1.Caption);
          Itemseguintefilho1.Caption := ReadString('MAINFORM','Itemseguintefilho1Caption',Itemseguintefilho1.Caption);
          lblDependent.Caption := ReadString('MAINFORM','lblDependentCaption',lblDependent.Caption);
          lblImage.Caption := ReadString('MAINFORM','lblImageCaption',lblImage.Caption);
          lblItemName.Caption := ReadString('MAINFORM','lblItemNameCaption',lblItemName.Caption);
          lblNotes.Caption := ReadString('MAINFORM','lblNotesCaption',lblNotes.Caption);
          lblRecords.Caption := ReadString('MAINFORM','lblRecordsCaption',lblRecords.Caption);
          Novoitemdependente1.Caption := ReadString('MAINFORM','Novoitemdependente1Caption',Novoitemdependente1.Caption);
          Novoitemfilho.Caption := ReadString('MAINFORM','NovoitemfilhoCaption',Novoitemfilho.Caption);
          Novoitempai.Caption := ReadString('MAINFORM','NovoitempaiCaption',Novoitempai.Caption);
          NovoitemPrincipal1.Caption := ReadString('MAINFORM','NovoitemPrincipal1Caption',NovoitemPrincipal1.Caption);
          Portugues1.Caption := ReadString('MAINFORM','Portugues1Caption',Portugues1.Caption);
          primeiroitem1.Caption := ReadString('MAINFORM','primeiroitem1Caption',primeiroitem1.Caption);
          Sair1.Caption := ReadString('MAINFORM','Sair1Caption',Sair1.Caption);
          Ver1.Caption := ReadString('MAINFORM','Ver1Caption',Ver1.Caption);
          ActAbout.Hint := ReadString('MAINFORM','ActAboutHint',ActAbout.Hint);
          ActAddPicture.Hint := ReadString('MAINFORM','ActAddPictureHint',ActAddPicture.Hint);
          ActCancel.Hint := ReadString('MAINFORM','ActCancelHint',ActCancel.Hint);
          ActClose.Hint := ReadString('MAINFORM','ActCloseHint',ActClose.Hint);
          ActDelete.Hint := ReadString('MAINFORM','ActDeleteHint',ActDelete.Hint);
          ActDeletePicture.Hint := ReadString('MAINFORM','ActDeletePictureHint',ActDeletePicture.Hint);
          ActEnglish.Hint := ReadString('MAINFORM','ActEnglishHint',ActEnglish.Hint);
          ActFrench.Hint := ReadString('MAINFORM','ActFrenchHint',ActFrench.Hint);
          ActGoDown.Hint := ReadString('MAINFORM','ActGoDownHint',ActGoDown.Hint);
          ActGoTop.Hint := ReadString('MAINFORM','ActGoTopHint',ActGoTop.Hint);
          ActGoUp.Hint := ReadString('MAINFORM','ActGoUpHint',ActGoUp.Hint);
          ActNewChild.Hint := ReadString('MAINFORM','ActNewChildHint',ActNewChild.Hint);
          ActNewSibling.Hint := ReadString('MAINFORM','ActNewSiblingHint',ActNewSibling.Hint);
          ActNext.Hint := ReadString('MAINFORM','ActNextHint',ActNext.Hint);
          ActPortuguese.Hint := ReadString('MAINFORM','ActPortugueseHint',ActPortuguese.Hint);
          ActSave.Hint := ReadString('MAINFORM','ActSaveHint',ActSave.Hint);
          ActSearch.Hint := ReadString('MAINFORM','ActSearchHint',ActSearch.Hint);
          ActSpanish.Hint := ReadString('MAINFORM','ActSpanishHint',ActSpanish.Hint);
          JvStrHolder.Strings[0]:= ReadString('MAINFORM','JvStrHolderStrings0',JvStrHolder.Strings[0]);
          JvStrHolder.Strings[1] := ReadString('MAINFORM','JvStrHolderStrings1',JvStrHolder.Strings[1]);
          JvStrHolder.Strings[2] := ReadString('MAINFORM','JvStrHolderStrings2',JvStrHolder.Strings[2]);
          JvStrHolder.Strings[3] := ReadString('MAINFORM','JvStrHolderStrings3',JvStrHolder.Strings[3]);
          JvStrHolder.Strings[4] := ReadString('MAINFORM','JvStrHolderStrings4',JvStrHolder.Strings[4]);
          JvStrHolder.Strings[5] := ReadString('MAINFORM','JvStrHolderStrings5',JvStrHolder.Strings[5]);
          JvStrHolder.Strings[6] := ReadString('MAINFORM','JvStrHolderStrings6',JvStrHolder.Strings[6]);
          JvStrHolder.Strings[7] := ReadString('MAINFORM','JvStrHolderStrings7',JvStrHolder.Strings[7]);
          JvStrHolder.Strings[8] := ReadString('MAINFORM','JvStrHolderStrings8',JvStrHolder.Strings[8]);
          JvStrHolder.Strings[9] := ReadString('MAINFORM','JvStrHolderStrings9',JvStrHolder.Strings[9]);
          JvStrHolder.Strings[10] := ReadString('MAINFORM','JvStrHolderStrings10',JvStrHolder.Strings[10]);
          JvStrHolder.Strings[11] := ReadString('MAINFORM','JvStrHolderStrings11',JvStrHolder.Strings[11]);
          JvStrHolder.Strings[12] := ReadString('MAINFORM','JvStrHolderStrings12',JvStrHolder.Strings[12]);
          JvStrHolder.Strings[13] := ReadString('MAINFORM','JvStrHolderStrings13',JvStrHolder.Strings[13]);
          JvStrHolder.Strings[14] := ReadString('MAINFORM','JvStrHolderStrings14',JvStrHolder.Strings[14]);
          JvStrHolder.Strings[15] := ReadString('MAINFORM','JvStrHolderStrings15',JvStrHolder.Strings[15]);
          JvStrHolder.Strings[16] := ReadString('MAINFORM','JvStrHolderStrings16',JvStrHolder.Strings[16]);
          OpenDialog1.Filter := ReadString('MAINFORM','OpenDialog1Filter',OpenDialog1.Filter);
          OpenDialog1.Title := ReadString('MAINFORM','OpenDialog1Title',OpenDialog1.Title);
        end;
    finally
      SettingsFile.Free;
    end; //try
  end //if
  else
    begin
      DefaultMainSettings;
      SaveMainSettings;
    end;
end;

procedure SaveMainSettings;
var
  SettingsFileName : TFileName;
  SettingsFile     : TIniFile;
begin
  SettingsFileName := ExtractFilePath(ParamStr(0)) +
    '\settings.ini';
  SettingsFile := TIniFile.Create(SettingsFileName);
  try
    with SettingsFile, frmMainForm do
      begin
        WriteString('MAINFORM','sLanguage',sLanguage);
        WriteInteger('MAINFORM','frmMainFormHeight',Height);
        WriteInteger('MAINFORM','frmMainFormWidth',Width);
        WriteInteger('MAINFORM','frmMainFormLeft',Left);
        WriteInteger('MAINFORM','frmMainFormTop',Top);
        WriteString('MAINFORM','Caption',Caption);
        WriteString('MAINFORM','Acerca1Caption',Acerca1.Caption);
        WriteString('MAINFORM','Acrescentarimagem1Caption',Acrescentarimagem1.Caption);
        WriteString('MAINFORM','Adicionarimagem1Caption',Adicionarimagem1.Caption);
        WriteString('MAINFORM','Ajuda1Caption',Ajuda1.Caption);
        WriteString('MAINFORM','btNodeCaption',btNode.Caption);
        WriteString('MAINFORM','btPKNODECaption',btPKNODE.Caption);
        WriteString('MAINFORM','Cancelar1Caption',Cancelar1.Caption);
        WriteString('MAINFORM','Cancelaralteracoes1Caption',Cancelaralteracoes1.Caption);
        WriteString('MAINFORM','Editar1Caption',Editar1.Caption);
        WriteString('MAINFORM','Eliminar1Caption',Eliminar1.Caption);
        WriteString('MAINFORM','Eliminarimagem1Caption',Eliminarimagem1.Caption);
        WriteString('MAINFORM','Eliminarimagem2Caption',Eliminarimagem2.Caption);
        WriteString('MAINFORM','Eliminaritem1Caption',Eliminaritem1.Caption);
        WriteString('MAINFORM','English1Caption',English1.Caption);
        WriteString('MAINFORM','Espanol1Caption',Espanol1.Caption);
        WriteString('MAINFORM','Ficheiro1Caption',Ficheiro1.Caption);
        WriteString('MAINFORM','Francais1Caption',Francais1.Caption);
        WriteString('MAINFORM','Guardar1Caption',Guardar1.Caption);
        WriteString('MAINFORM','Guardar2Caption',Guardar2.Caption);
        WriteString('MAINFORM','Idioma1Caption',Idioma1.Caption);
        WriteString('MAINFORM','Itemanterior1Caption',Itemanterior1.Caption);
        WriteString('MAINFORM','Itemseguinte1Caption',Itemseguinte1.Caption);
        WriteString('MAINFORM','Itemseguintefilho1Caption',Itemseguintefilho1.Caption);
        WriteString('MAINFORM','lblDependentCaption',lblDependent.Caption);
        WriteString('MAINFORM','lblImageCaption',lblImage.Caption);
        WriteString('MAINFORM','lblItemNameCaption',lblItemName.Caption);
        WriteString('MAINFORM','lblNotesCaption',lblNotes.Caption);
        WriteString('MAINFORM','lblRecordsCaption',lblRecords.Caption);
        WriteString('MAINFORM','Novoitemdependente1Caption',Novoitemdependente1.Caption);
        WriteString('MAINFORM','NovoitemfilhoCaption',Novoitemfilho.Caption);
        WriteString('MAINFORM','NovoitempaiCaption',Novoitempai.Caption);
        WriteString('MAINFORM','NovoitemPrincipal1Caption',NovoitemPrincipal1.Caption);
        WriteString('MAINFORM','Portugues1Caption',Portugues1.Caption);
        WriteString('MAINFORM','primeiroitem1Caption',primeiroitem1.Caption);
        WriteString('MAINFORM','Sair1Caption',Sair1.Caption);
        WriteString('MAINFORM','Ver1Caption',Ver1.Caption);
        WriteString('MAINFORM','ActAboutHint',ActAbout.Hint);
        WriteString('MAINFORM','ActAddPictureHint',ActAddPicture.Hint);
        WriteString('MAINFORM','ActCancelHint',ActCancel.Hint);
        WriteString('MAINFORM','ActCloseHint',ActClose.Hint);
        WriteString('MAINFORM','ActDeleteHint',ActDelete.Hint);
        WriteString('MAINFORM','ActDeletePictureHint',ActDeletePicture.Hint);
        WriteString('MAINFORM','ActEnglishHint',ActEnglish.Hint);
        WriteString('MAINFORM','ActFrenchHint',ActFrench.Hint);
        WriteString('MAINFORM','ActGoDownHint',ActGoDown.Hint);
        WriteString('MAINFORM','ActGoTopHint',ActGoTop.Hint);
        WriteString('MAINFORM','ActGoUpHint',ActGoUp.Hint);
        WriteString('MAINFORM','ActNewChildHint',ActNewChild.Hint);
        WriteString('MAINFORM','ActNewSiblingHint',ActNewSibling.Hint);
        WriteString('MAINFORM','ActNextHint',ActNext.Hint);
        WriteString('MAINFORM','ActPortugueseHint',ActPortuguese.Hint);
        WriteString('MAINFORM','ActSaveHint',ActSave.Hint);
        WriteString('MAINFORM','ActSearchHint',ActSearch.Hint);
        WriteString('MAINFORM','ActSpanishHint',ActSpanish.Hint);
        WriteString('MAINFORM','JvStrHolderStrings0',JvStrHolder.Strings[0]);
        WriteString('MAINFORM','JvStrHolderStrings1',JvStrHolder.Strings[1]);
        WriteString('MAINFORM','JvStrHolderStrings2',JvStrHolder.Strings[2]);
        WriteString('MAINFORM','JvStrHolderStrings3',JvStrHolder.Strings[3]);
        WriteString('MAINFORM','JvStrHolderStrings4',JvStrHolder.Strings[4]);
        WriteString('MAINFORM','JvStrHolderStrings5',JvStrHolder.Strings[5]);
        WriteString('MAINFORM','JvStrHolderStrings6',JvStrHolder.Strings[6]);
        WriteString('MAINFORM','JvStrHolderStrings7',JvStrHolder.Strings[7]);
        WriteString('MAINFORM','JvStrHolderStrings8',JvStrHolder.Strings[8]);
        WriteString('MAINFORM','JvStrHolderStrings9',JvStrHolder.Strings[9]);
        WriteString('MAINFORM','JvStrHolderStrings10',JvStrHolder.Strings[10]);
        WriteString('MAINFORM','JvStrHolderStrings11',JvStrHolder.Strings[11]);
        WriteString('MAINFORM','JvStrHolderStrings12',JvStrHolder.Strings[12]);
        WriteString('MAINFORM','JvStrHolderStrings13',JvStrHolder.Strings[13]);
        WriteString('MAINFORM','JvStrHolderStrings14',JvStrHolder.Strings[14]);
        WriteString('MAINFORM','JvStrHolderStrings15',JvStrHolder.Strings[15]);
        WriteString('MAINFORM','JvStrHolderStrings16',JvStrHolder.Strings[16]);
        WriteString('MAINFORM','OpenDialog1Filter',OpenDialog1.Filter);
        WriteString('MAINFORM','OpenDialog1Title',OpenDialog1.Title);
      end;
  finally
    SettingsFile.Free;
  end; //try
end;

procedure DefaultMainSettings;
begin
  with frmMainForm do
    begin
      sLanguage := 'Portugus';
      Height := 583;
      Width := 582;
      Left := 201;
      Top := 20;
      Caption := 'Informtica - produtos relacionados por grupos';
      Acerca1.Caption := 'Acerca...';
      Acrescentarimagem1.Caption := 'Adicionar imagem';
      Adicionarimagem1.Caption := 'Adicionar imagem';
      Ajuda1.Caption := 'Ajuda';
      btNode.Caption := 'DBADOTree: nmero do ndulo';
      btPKNODE.Caption := 'Tabela: valores dos campos PK e NODE';
      Cancelar1.Caption := 'Cancelar alteraes';
      Cancelaralteracoes1.Caption := 'Cancelar alteraes';
      Editar1.Caption := 'Editar';
      Eliminar1.Caption := 'Eliminar item';
      Eliminarimagem1.Caption := 'Eliminar imagem';
      Eliminarimagem2.Caption := 'Eliminar imagem';
      Eliminaritem1.Caption := 'Eliminar item';
      English1.Caption := 'English';
      Espanol1.Caption := 'Espaol';
      Ficheiro1.Caption := 'Ficheiro';
      Francais1.Caption := 'Franais';
      Guardar1.Caption := 'Guardar';
      Guardar2.Caption := 'Guardar';
      Idioma1.Caption := 'Idioma';
      Itemanterior1.Caption := 'item anterior';
      Itemseguinte1.Caption := 'item seguinte';
      Itemseguintefilho1.Caption := 'item dependente';
      lblDependent.Caption := 'Dependente(s):';
      lblImage.Caption := 'Imagem do produto:';
      lblItemName.Caption := 'Nome do item:';
      lblNotes.Caption := 'Descrio do produto:';
      lblRecords.Caption := 'Total de registos:';
      Novoitemdependente1.Caption := 'Novo item Dependente';
      Novoitemfilho.Caption := 'Novo item Dependente';
      Novoitempai.Caption := 'Novo item Principal';
      NovoitemPrincipal1.Caption := 'Novo item Principal';
      Portugues1.Caption := 'Portugus';
      primeiroitem1.Caption := 'primeiro item';
      Sair1.Caption := 'Sair';
      Ver1.Caption := 'Ir para';
      ActAbout.Hint := 'acerca|Acerca do programa...';
      ActAddPicture.Hint := 'adicionar imagem|adicionar imagem';
      ActCancel.Hint := 'cancelar|cancelar as alteraes';
      ActClose.Hint := 'fechar|fechar o programa';
      ActDelete.Hint := 'eliminar|eliminar item';
      ActDeletePicture.Hint := 'eliminar imagem|eliminar imagem';
      ActEnglish.Hint := 'English|English language';
      ActFrench.Hint := 'Franais|langage Franais';
      ActGoDown.Hint := 'item dependente|ir para o item dependente';
      ActGoTop.Hint := 'primeiro item|ir para o primeiro item';
      ActGoUp.Hint := 'item anterior|ir para o item anterior';
      ActNewChild.Hint := 'novo dependente (filho)|novo item dependente (filho)';
      ActNewSibling.Hint := 'novo principal (irmo)|novo item principal (irmo)';
      ActNext.Hint := 'item seguinte (todos)|percorrer todos os itens';
      ActPortuguese.Hint := 'Portugus|idioma portugus';
      ActSave.Hint := 'guardar|guardar as alteraes';
      ActSearch.Hint := 'procurar|procurar um item';
      ActSpanish.Hint := 'Espaol|idioma espaol';
      JvStrHolder.Strings[0] := 'A tabela TEM alteraes no guardadas';
      JvStrHolder.Strings[1] := 'A tabela no tem alteraes por guardar';
      JvStrHolder.Strings[2] := 'As alteraes no foram guardadas. Guardar agora?';
      JvStrHolder.Strings[3] := 'Ateno!';
      JvStrHolder.Strings[4] := 'O item seleccionado tem dependentes.';
      JvStrHolder.Strings[5] := 'No pode ser eliminado.';
      JvStrHolder.Strings[6] := 'Informao';
      JvStrHolder.Strings[7] := 'Eliminar o item ''%s''?';
      JvStrHolder.Strings[8] := 'Eliminar a imagem?';
      JvStrHolder.Strings[9] := 'Novo item Principal';
      JvStrHolder.Strings[10] := 'Digite o nome do novo item:';
      JvStrHolder.Strings[11] := 'No pode criar dependentes do item seleccionado.';
      JvStrHolder.Strings[12] := 'Novo item Dependente';
      JvStrHolder.Strings[13] := 'Valores dos campos da tabela:';
      JvStrHolder.Strings[14] := 'DTADOTree: Ndulo %s';
      JvStrHolder.Strings[15] := 'Com dependente(s)';
      JvStrHolder.Strings[16] := 'Sem dependente(s)';
      OpenDialog1.Filter := 'Mapa de bits (*.bmp;*.dib)|*.bmp;*.dib|JPEG (*.jpg;*.jpeg;*.jpe;*.jfif)|*.jpg;*.jpeg;*.jpe;*.jfif';
      OpenDialog1.Title := 'Abrir ficheiro de imagem';
    end;
end;

procedure LoadAboutSettings;
var
  SettingsFileName : TFileName;
  SettingsFile     : TIniFile;
begin
  SettingsFileName := ExtractFilePath(ParamStr(0)) +
    '\settings.ini';
  if FileExists(SettingsFileName) then
  begin
    SettingsFile := TIniFile.Create(SettingsFileName);
    try
      with SettingsFile, AboutBox do
        begin
          Height := ReadInteger('ABOUTBOX','AboutHeight',Height);
          Width := ReadInteger('ABOUTBOX','AboutWidth',Width);
          Left := ReadInteger('ABOUTBOX','AboutLeft',Left);
          Top := ReadInteger('ABOUTBOX','AboutTop',Top);
          Caption := ReadString('ABOUTBOX','Caption',Caption);
          Comments1.Caption := ReadString('ABOUTBOX','Comments1Caption',Comments1.Caption);
          Comments2.Caption := ReadString('ABOUTBOX','Comments2Caption',Comments2.Caption);
          Comments3.Caption := ReadString('ABOUTBOX','Comments3Caption',Comments3.Caption);
          Comments4.Caption := ReadString('ABOUTBOX','Comments4Caption',Comments4.Caption);
          Comments5.Caption := ReadString('ABOUTBOX','Comments5Caption',Comments5.Caption);
          Comments6.Caption := ReadString('ABOUTBOX','Comments6Caption',Comments6.Caption);
          Copyright.Caption := ReadString('ABOUTBOX','CopyrightCaption',Copyright.Caption);
          lblemail.Caption := ReadString('ABOUTBOX','lblemailCaption',lblemail.Caption);
          OKButton.Caption := ReadString('ABOUTBOX','OKButtonCaption',OKButton.Caption);
          ProductName.Caption := ReadString('ABOUTBOX','ProductNameCaption',ProductName.Caption);
          Version.Caption := ReadString('ABOUTBOX','VersionCaption',Version.Caption);
        end; //with
    finally
      SettingsFile.Free;
    end; //try
  end //if
  else
    begin
      DefaultAboutSettings;
      SaveAboutSettings;
    end;
end;

procedure SaveAboutSettings;
var
  SettingsFileName : TFileName;
  SettingsFile     : TIniFile;
begin
  SettingsFileName := ExtractFilePath(ParamStr(0)) +
    '\settings.ini';
  SettingsFile := TIniFile.Create(SettingsFileName);
  try
    with SettingsFile, AboutBox do
      begin
        WriteInteger('ABOUTBOX','AboutHeight',Height);
        WriteInteger('ABOUTBOX','AboutWidth',Width);
        WriteInteger('ABOUTBOX','AboutLeft',Left);
        WriteInteger('ABOUTBOX','AboutTop',Top);
        WriteString('ABOUTBOX','Caption',Caption);
        WriteString('ABOUTBOX','Comments1Caption',Comments1.Caption);
        WriteString('ABOUTBOX','Comments2Caption',Comments2.Caption);
        WriteString('ABOUTBOX','Comments3Caption',Comments3.Caption);
        WriteString('ABOUTBOX','Comments4Caption',Comments4.Caption);
        WriteString('ABOUTBOX','Comments5Caption',Comments5.Caption);
        WriteString('ABOUTBOX','Comments6Caption',Comments6.Caption);
        WriteString('ABOUTBOX','CopyrightCaption',Copyright.Caption);
        WriteString('ABOUTBOX','lblemailCaption',lblemail.Caption);
        WriteString('ABOUTBOX','OKButtonCaption',OKButton.Caption);
        WriteString('ABOUTBOX','ProductNameCaption',ProductName.Caption);
        WriteString('ABOUTBOX','VersionCaption',Version.Caption);
      end;
  finally
    SettingsFile.Free;
  end; //try
end;

procedure DefaultAboutSettings;
begin
  with AboutBox do
    begin
      Height := 316;
      Width := 318;
      Left := 200;
      Top := 108;
      Caption := 'Acerca do programa...';
      Comments1.Caption := 'Permite ver itens usando uma DTADOTree.';
      Comments2.Caption := 'Usa botes ligados a Actions para inserir';
      Comments3.Caption := 'um novo item, guardar, cancelar, eliminar...';
      Comments4.Caption := 'Elaborado com Embarcadero RAD Studio.';
      Comments5.Caption := 'O programa  de utilizao livre.';
      Comments6.Caption := 'Qualquer alterao deve ser comunicada ao Autor.';
      Copyright.Caption := 'Copyright , 2015, by Alvaro Ferreira Alves';
      lblemail.Caption := 'https://www.alferes.net';
      OKButton.Caption := 'OK';
      ProductName.Caption := 'Produtos de Informtica';
      Version.Caption := 'Verso 1.1';
    end;
end;

end.
